/*
 * File         : BV_Application.h
 * Author       : Tomasz Stachowiak
 * Created      : Fri Jul 24 16:35:36 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __BV_APPLICATION_H
#define __BV_APPLICATION_H

#include "rtp.h"
#include "BV_Session_Control.h"
#include "BV.h"
#include "UserData.h"
#include "BV_AppReadThread.h"

class BV_Application
{
 public:

  BV_Application(int port);
  ~BV_Application();
  int init();
  void close();
  int send_data(int type, char *data, int len);
  virtual int process_message(RTPheader *header, char *body, int len) = 0;
  int get_data_sock();

 protected:

  int send_packet(int sock, int hostid, int port, char *msg, int len);
  void fill_rtp_header(RTPheader *header, unsigned int payload);
  unsigned int get_time_stamp();
  int get_internal_id(int id);
  void update_user_data(RTPheader *header, int len);

  BV_AppReadThread *read_thread_;
  int data_sock_;
  int port_;
  BV_Session_Control *sess_ctrl;
  int sequence;
  UserData *user_data[MAX_MEMBERS];
};

#endif


